diff -cr sendmail-8.9.0/src/srvrsmtp.c sendmail-8.9.1/src/srvrsmtp.c
*** sendmail-8.9.0/src/srvrsmtp.c	Tue May 19 16:36:07 1998
--- sendmail-8.9.1/src/srvrsmtp.c	Mon Jun 15 10:31:47 1998
***************
*** 14,22 ****
  
  #ifndef lint
  #if SMTP
! static char sccsid[] = "@(#)srvrsmtp.c	8.177 (Berkeley) 5/19/98 (with SMTP)";
  #else
! static char sccsid[] = "@(#)srvrsmtp.c	8.177 (Berkeley) 5/19/98 (without SMTP)";
  #endif
  #endif /* not lint */
  
--- 14,22 ----
  
  #ifndef lint
  #if SMTP
! static char sccsid[] = "@(#)srvrsmtp.c	8.181 (Berkeley) 6/15/98 (with SMTP)";
  #else
! static char sccsid[] = "@(#)srvrsmtp.c	8.181 (Berkeley) 6/15/98 (without SMTP)";
  #endif
  #endif /* not lint */
  
***************
*** 127,132 ****
--- 127,133 ----
  	char *id;
  	volatile int nrcpts = 0;	/* number of RCPT commands */
  	bool doublequeue;
+ 	bool discard;
  	volatile int badcommands = 0;	/* count of bad commands */
  	volatile int nverifies = 0;	/* count of VRFY/EXPN commands */
  	volatile int n_etrn = 0;	/* count of ETRN commands */
***************
*** 159,164 ****
--- 160,168 ----
  	if (CurSmtpClient == NULL)
  		CurSmtpClient = CurHostName;
  
+ 	/* check_relay may have set discard bit, save for later */
+ 	discard = bitset(EF_DISCARD, e->e_flags);
+ 
  	setproctitle("server %s startup", CurSmtpClient);
  #if DAEMON
  	if (LogLevel > 11)
***************
*** 429,435 ****
  				message("250-DSN");
  #endif
  			message("250-ONEX");
! 			message("250-ETRN");
  			message("250-XUSR");
  			message("250 HELP");
  			break;
--- 433,440 ----
  				message("250-DSN");
  #endif
  			message("250-ONEX");
! 			if (!bitset(PRIV_NOETRN, PrivacyFlags))
! 				message("250-ETRN");
  			message("250-XUSR");
  			message("250 HELP");
  			break;
***************
*** 716,721 ****
--- 721,730 ----
  				break;
  			}
  
+ 			/* put back discard bit */
+ 			if (discard)
+ 				e->e_flags |= EF_DISCARD;
+ 
  			/* check to see if we need to re-expand aliases */
  			/* also reset QBADADDR on already-diagnosted addrs */
  			doublequeue = FALSE;
***************
*** 853,859 ****
  					sm_syslog(LOG_INFO, e->e_id,
  						"%.100s: %s [rejected]",
  						CurSmtpClient,
! 						shortenstring(inp, 203));
  				break;
  			}
  			else if (!gothello &&
--- 862,868 ----
  					sm_syslog(LOG_INFO, e->e_id,
  						"%.100s: %s [rejected]",
  						CurSmtpClient,
! 						shortenstring(inp, MAXSHORTSTR));
  				break;
  			}
  			else if (!gothello &&
***************
*** 871,877 ****
  				sm_syslog(LOG_INFO, e->e_id,
  					"%.100s: %s",
  					CurSmtpClient,
! 					shortenstring(inp, 203));
  			if (setjmp(TopFrame) > 0)
  				goto undo_subproc;
  			QuickAbort = TRUE;
--- 880,886 ----
  				sm_syslog(LOG_INFO, e->e_id,
  					"%.100s: %s",
  					CurSmtpClient,
! 					shortenstring(inp, MAXSHORTSTR));
  			if (setjmp(TopFrame) > 0)
  				goto undo_subproc;
  			QuickAbort = TRUE;
***************
*** 918,924 ****
  					sm_syslog(LOG_INFO, e->e_id,
  						"%.100s: %s [rejected]",
  						CurSmtpClient,
! 						shortenstring(inp, 203));
  				break;
  			}
  
--- 927,933 ----
  					sm_syslog(LOG_INFO, e->e_id,
  						"%.100s: %s [rejected]",
  						CurSmtpClient,
! 						shortenstring(inp, MAXSHORTSTR));
  				break;
  			}
  
***************
*** 935,941 ****
  				sm_syslog(LOG_INFO, e->e_id,
  					"%.100s: ETRN %s",
  					CurSmtpClient,
! 					shortenstring(p, 203));
  
  			id = p;
  			if (*id == '@')
--- 944,950 ----
  				sm_syslog(LOG_INFO, e->e_id,
  					"%.100s: ETRN %s",
  					CurSmtpClient,
! 					shortenstring(p, MAXSHORTSTR));
  
  			id = p;
  			if (*id == '@')
***************
*** 1044,1050 ****
  			}
  
  			usrerr("500 Command unrecognized: \"%s\"",
! 				shortenstring(inp, 203));
  			break;
  
  		  default:
--- 1053,1059 ----
  			}
  
  			usrerr("500 Command unrecognized: \"%s\"",
! 				shortenstring(inp, MAXSHORTSTR));
  			break;
  
  		  default:
***************
*** 1126,1132 ****
  	{
  	  syntax:
  		usrerr("501 Syntax error in parameters scanning \"%s\"",
! 			shortenstring(firstp, 203));
  		return (NULL);
  	}
  	*p++ = '\0';
--- 1135,1141 ----
  	{
  	  syntax:
  		usrerr("501 Syntax error in parameters scanning \"%s\"",
! 			shortenstring(firstp, MAXSHORTSTR));
  		return (NULL);
  	}
  	*p++ = '\0';
diff -cr sendmail-8.9.0/src/sysexits.c sendmail-8.9.1/src/sysexits.c
*** sendmail-8.9.0/src/sysexits.c	Tue May 19 16:36:02 1998
--- sendmail-8.9.1/src/sysexits.c	Sun May 24 14:03:36 1998
***************
*** 11,20 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)sysexits.c	8.12 (Berkeley) 5/19/98";
  #endif /* not lint */
  
! #include <sendmail.h>
  
  /*
  **  SYSEXITS.C -- error messages corresponding to sysexits.h
--- 11,20 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)sysexits.c	8.13 (Berkeley) 5/24/98";
  #endif /* not lint */
  
! #include "sendmail.h"
  
  /*
  **  SYSEXITS.C -- error messages corresponding to sysexits.h
diff -cr sendmail-8.9.0/src/udb.c sendmail-8.9.1/src/udb.c
*** sendmail-8.9.0/src/udb.c	Tue May 19 16:36:09 1998
--- sendmail-8.9.1/src/udb.c	Wed Jun 24 11:26:47 1998
***************
*** 14,22 ****
  
  #ifndef lint
  #if USERDB
! static char sccsid [] = "@(#)udb.c	8.63 (Berkeley) 5/19/98 (with USERDB)";
  #else
! static char sccsid [] = "@(#)udb.c	8.63 (Berkeley) 5/19/98 (without USERDB)";
  #endif
  #endif
  
--- 14,22 ----
  
  #ifndef lint
  #if USERDB
! static char sccsid [] = "@(#)udb.c	8.66 (Berkeley) 6/18/98 (with USERDB)";
  #else
! static char sccsid [] = "@(#)udb.c	8.66 (Berkeley) 6/18/98 (without USERDB)";
  #endif
  #endif
  
***************
*** 323,329 ****
  				sm_syslog(LOG_INFO, e->e_id,
  					"expand %.100s => %s",
  					e->e_to,
! 					shortenstring(user, 203));
  			naddrs = sendtolist(user, a, sendq, aliaslevel + 1, e);
  			if (naddrs > 0 && !bitset(QSELFREF, a->q_flags))
  			{
--- 323,329 ----
  				sm_syslog(LOG_INFO, e->e_id,
  					"expand %.100s => %s",
  					e->e_to,
! 					shortenstring(user, MAXSHORTSTR));
  			naddrs = sendtolist(user, a, sendq, aliaslevel + 1, e);
  			if (naddrs > 0 && !bitset(QSELFREF, a->q_flags))
  			{
***************
*** 461,467 ****
  				sm_syslog(LOG_INFO, e->e_id,
  					"hesiod %.100s => %s",
  					e->e_to,
! 					shortenstring(user, 203));
  			naddrs = sendtolist(user, a, sendq, aliaslevel + 1, e);
  
  			if (naddrs > 0 && !bitset(QSELFREF, a->q_flags))
--- 461,467 ----
  				sm_syslog(LOG_INFO, e->e_id,
  					"hesiod %.100s => %s",
  					e->e_to,
! 					shortenstring(user, MAXSHORTSTR));
  			naddrs = sendtolist(user, a, sendq, aliaslevel + 1, e);
  
  			if (naddrs > 0 && !bitset(QSELFREF, a->q_flags))
***************
*** 641,647 ****
  			if (tTd(28, 1))
  				printf("udbmatch ==> %s\n", p);
  			return p;
- 			break;
  #endif
  
  #ifdef HESIOD
--- 641,646 ----
***************
*** 742,748 ****
  			if (tTd(28, 1))
  				printf("udbmatch ==> %s\n", p);
  			return p;
- 			break;
  #endif
  
  #ifdef HESIOD
--- 741,746 ----
***************
*** 809,814 ****
--- 807,813 ----
  **		The rewritten name otherwise.
  */
  
+ /* ARGSUSED3 */
  char *
  udb_map_lookup(map, name, av, statp)
  	MAP *map;
***************
*** 868,873 ****
--- 867,873 ----
  _udbx_init(e)
  	ENVELOPE *e;
  {
+ 	int ents = 0;
  	register char *p;
  	register struct udbent *up;
  
***************
*** 884,890 ****
  	while (p != NULL)
  	{
  		char *spec;
- 		int nopts;
  		int l;
  # if 0
  		auto int rcode;
--- 884,889 ----
***************
*** 905,912 ****
  		if (p != NULL)
  			*p++ = '\0';
  
  		/* extract options */
! 		nopts = _udb_parsespec(spec, opts, MAXUDBOPTS);
  
  		/*
  		**  Decode database specification.
--- 904,917 ----
  		if (p != NULL)
  			*p++ = '\0';
  
+ 		if (ents >= MAXUDBENT)
+ 		{
+ 			syserr("Maximum number of UDB entries exceeded");
+ 			break;
+ 		}
+ 
  		/* extract options */
! 		(void) _udb_parsespec(spec, opts, MAXUDBOPTS);
  
  		/*
  		**  Decode database specification.
***************
*** 973,978 ****
--- 978,984 ----
  				      INADDRSZ);
  				up->udb_addr.sin_port = UdbPort;
  				up->udb_timeout = UdbTimeout;
+ 				ents++;
  				up++;
  			}
  
***************
*** 988,993 ****
--- 994,1000 ----
  		  case '@':	/* forward to remote host */
  			up->udb_type = UDB_FORWARD;
  			up->udb_fwdhost = spec + 1;
+ 			ents++;
  			up++;
  			break;
  
***************
*** 997,1002 ****
--- 1004,1010 ----
  			if (strcasecmp(spec, "hesiod") != 0)
  				goto badspec;
  			up->udb_type = UDB_HESIOD;
+ 			ents++;
  			up++;
  			break;
  #endif /* HESIOD */
***************
*** 1059,1064 ****
--- 1067,1073 ----
  				break;
  			}
  			up->udb_type = UDB_DBFETCH;
+ 			ents++;
  			up++;
  			break;
  #endif
diff -cr sendmail-8.9.0/src/usersmtp.c sendmail-8.9.1/src/usersmtp.c
*** sendmail-8.9.0/src/usersmtp.c	Tue May 19 16:36:02 1998
--- sendmail-8.9.1/src/usersmtp.c	Thu Jul  2 10:49:58 1998
***************
*** 14,22 ****
  
  #ifndef lint
  #if SMTP
! static char sccsid[] = "@(#)usersmtp.c	8.102 (Berkeley) 5/19/98 (with SMTP)";
  #else
! static char sccsid[] = "@(#)usersmtp.c	8.102 (Berkeley) 5/19/98 (without SMTP)";
  #endif
  #endif /* not lint */
  
--- 14,22 ----
  
  #ifndef lint
  #if SMTP
! static char sccsid[] = "@(#)usersmtp.c	8.104 (Berkeley) 6/30/98 (with SMTP)";
  #else
! static char sccsid[] = "@(#)usersmtp.c	8.104 (Berkeley) 6/30/98 (without SMTP)";
  #endif
  #endif /* not lint */
  
***************
*** 480,486 ****
  	else if (r == 552)
  	{
  		/* exceeded storage allocation */
! 		mci_setstat(mci, EX_NOTSTICKY, "5.2.2", SmtpReplyBuffer);
  		if (bitset(MCIF_SIZE, mci->mci_flags))
  			e->e_flags |= EF_NO_BODY_RETN;
  		return EX_UNAVAILABLE;
--- 480,486 ----
  	else if (r == 552)
  	{
  		/* exceeded storage allocation */
! 		mci_setstat(mci, EX_NOTSTICKY, "5.3.4", SmtpReplyBuffer);
  		if (bitset(MCIF_SIZE, mci->mci_flags))
  			e->e_flags |= EF_NO_BODY_RETN;
  		return EX_UNAVAILABLE;
***************
*** 1026,1032 ****
  					int plen;
  
  					snprintf(p, wbufleft, "%s... ",
! 						shortenstring(e->e_to, 203));
  					plen = strlen(p);
  					p += plen;
  					wbufleft -= plen;
--- 1026,1032 ----
  					int plen;
  
  					snprintf(p, wbufleft, "%s... ",
! 						shortenstring(e->e_to, MAXSHORTSTR));
  					plen = strlen(p);
  					p += plen;
  					wbufleft -= plen;
diff -cr sendmail-8.9.0/src/util.c sendmail-8.9.1/src/util.c
*** sendmail-8.9.0/src/util.c	Tue May 19 16:36:07 1998
--- sendmail-8.9.1/src/util.c	Wed Jul  1 19:22:50 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)util.c	8.156 (Berkeley) 5/19/98";
  #endif /* not lint */
  
  # include "sendmail.h"
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)util.c	8.159 (Berkeley) 7/1/98";
  #endif /* not lint */
  
  # include "sendmail.h"
***************
*** 386,391 ****
--- 386,393 ----
  				if (c == MACRODEXPAND)
  					putchar('&');
  				shiftout = TRUE;
+ 				if (*s == '\0')
+ 					continue;
  				if (strchr("=~&?", *s) != NULL)
  					putchar(*s++);
  				if (bitset(0200, *s))
***************
*** 922,927 ****
--- 924,930 ----
  	return (buf);
  }
  
+ /* ARGSUSED */
  static void
  readtimeout(timeout)
  	time_t timeout;
***************
*** 1778,1784 ****
  		sm_syslog(LOG_NOTICE, CurEnv->e_id,
  			"POSSIBLE ATTACK from %.100s: newline in string \"%s\"",
  			RealHostName == NULL ? "[UNKNOWN]" : RealHostName,
! 			shortenstring(bp, 203));
  	}
  
  	return bp;
--- 1781,1787 ----
  		sm_syslog(LOG_NOTICE, CurEnv->e_id,
  			"POSSIBLE ATTACK from %.100s: newline in string \"%s\"",
  			RealHostName == NULL ? "[UNKNOWN]" : RealHostName,
! 			shortenstring(bp, MAXSHORTSTR));
  	}
  
  	return bp;
diff -cr sendmail-8.9.0/src/version.c sendmail-8.9.1/src/version.c
*** sendmail-8.9.0/src/version.c	Tue May 19 16:36:05 1998
--- sendmail-8.9.1/src/version.c	Thu Jul  2 11:04:58 1998
***************
*** 11,17 ****
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)version.c	8.9 (Berkeley) 5/19/98";
  #endif /* not lint */
  
! char	Version[] = "8.9.0";
--- 11,17 ----
   */
  
  #ifndef lint
! static char sccsid[] = "@(#)version.c	8.9.1.1 (Berkeley) 7/2/98";
  #endif /* not lint */
  
! char	Version[] = "8.9.1";
